/* numfilt 0.1 - Copyright (c) 1997 Michael Binder                  */
/*                                                                  */
/* License                                                          */
/* -------                                                          */
/* see the file README distributed with this file.                  */

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <ctype.h>

#define TRUE 1
#define FALSE 0

int CheckDigits();
char *DigitToWord();
char *TenToNintynine(); 

static char inpbuf[2049];
static int  i, offset;
static int  rawflg, nlflg;

void main(int argc, char *argv[])
{
     rawflg=FALSE;
     nlflg=FALSE;
     for (i=2; i<=argc; i++)
     {
        if (strchr(argv[i-1],'r') != 0) rawflg=TRUE;
        if (strchr(argv[i-1],'n') != 0) nlflg=TRUE;
     }

     for(;;)
     {
         if (!fgets(inpbuf,2048,stdin))
         {
             if (nlflg == FALSE) fprintf(stdout,"\n");
             break;
         }
         if (nlflg == FALSE) sprintf(inpbuf+strlen(inpbuf)-1," ");
         for (i=0; i<strlen(inpbuf); i++)
         {
            if (isdigit(inpbuf[i]) == 0)
               fprintf(stdout,"%c",inpbuf[i]);
            else
            {
               if (rawflg == TRUE) fprintf(stdout," %s ",DigitToWord(inpbuf[i]));
               else
               {
                  offset=CheckDigits(&inpbuf[i]);
                  i=i+offset;
               }
            }
         }
     }
}


int CheckDigits(char *dg)
{
   static char nums[128], word[9];
   static int  i, j, k;

   sprintf(nums,"\0");
   for (i=0; i<strlen(dg); i++)
   {
      if ((nums[0] == '\0') && (dg[i] == '0')) continue;
      if (isdigit(dg[i]) == 0) break;
         else sprintf(nums+strlen(nums),"%c",dg[i]);
   }
   if (strlen(nums) == 0) sprintf(nums,"0");
   k=strlen(nums);
   if (k>12)
   { for (j=0; j<k; j++)
         fprintf(stdout," %s ",DigitToWord(dg[j]));
     return(i -1);
   }

   if (strlen(nums) > 1)
   {
      for (j=0; j<strlen(nums); j++)
      {
         sprintf(word,"%s",DigitToWord(nums[j]));
         if ((k>1) && (nums[j] == '1')) sprintf(word,"ein");
         switch(k)
         {
            case 12 : if (nums[j] != '0') fprintf(stdout," %shundert ",word); break;
            case 11 : { fprintf(stdout," %s Milliarden ",TenToNintynine(nums[j],nums[j+1]));
                        j++; k--;
                      } break;
            case 10 : { if (strlen(nums) == 10)
                        {  if (strcmp(word,"ein") == 0)
                              fprintf(stdout," eine Miliarde ",word);
                           else
                              fprintf(stdout," %s Millionen ",word);
                        }
                      } break;
            case  9 : if (nums[j] != '0') fprintf(stdout," %shundert ",word); break;
            case  8 : { fprintf(stdout," %s Millionen ",TenToNintynine(nums[j],nums[j+1]));
                        j++; k--;
                      } break;
            case  7 : { if (strlen(nums) == 7)
                        {  if (strcmp(word,"ein") == 0)
                              fprintf(stdout," eine Milion ",word);
                           else
                              fprintf(stdout," %s Millionen ",word);
                        }
                      } break;
            case  6 : if (nums[j] != '0') fprintf(stdout," %shundert ",word); break;
            case  5 : { fprintf(stdout," %s tausend ",TenToNintynine(nums[j],nums[j+1]));
                        j++; k--;
                      } break;
            case  4 : { if (strlen(nums) == 4)
                           fprintf(stdout," %stausend ",word);
                      } break;
            case  3 : if (nums[j] != '0') fprintf(stdout," %shundert ",word); break;
            case  2 : { fprintf(stdout," %s ",TenToNintynine(nums[j],nums[j+1]));
                        j=j+2;
                      } break;
         }
         k--;
      } 
   }

   if ((dg[i] == '.') &&
       ((dg[i+1] == ' ') || (dg[i+1] == '\0') || (dg[i+1] == '\n')))
   {
      if (strcmp(nums,"1") == 0) fprintf(stdout," erstens ");
         else
      if (strcmp(nums,"3") == 0) fprintf(stdout," drittens ");
         else
      if (strcmp(nums,"7") == 0) fprintf(stdout," siebtens ");
         else
      if (strlen(nums) == 1) fprintf(stdout,"%stens ",DigitToWord(nums[0]));
         else fprintf(stdout,"tens ");
   }
   else
   {
      if (strlen(nums) == 1)
      fprintf(stdout," %s ",DigitToWord(nums[0]));
   }

   if ((dg[i] == '.') && (isdigit(dg[i+1]) != 0))
   {
      fprintf(stdout," Punkt ");
   }

   if ((dg[i] == ',') && (isdigit(dg[i+1]) != 0))
   {
      fprintf(stdout," Komma ");
   }
   return((i-1));
}

char *DigitToWord(int c)
{
     static char word[9];

     switch(c)
     {
        case '0' : sprintf(word,"null"); break;
        case '1' : sprintf(word,"eins"); break;
        case '2' : sprintf(word,"zwei"); break; 
        case '3' : sprintf(word,"drei"); break;
        case '4' : sprintf(word,"vier"); break;
        case '5' : sprintf(word,"f\"unf"); break;
        case '6' : sprintf(word,"sechs"); break;
        case '7' : sprintf(word,"sieben"); break;
        case '8' : sprintf(word,"acht"); break;
        case '9' : sprintf(word,"neun"); break;
     }
     return(word);
}

char *TenToNintynine(int c1, int c2)
{
   static char german_number[128];

   if ((c1 == '1') && (c2 == '1'))
   {  sprintf(german_number,"elf");
      return(german_number);
   }
   if ((c1 == '1') && (c2 == '2'))
   {  sprintf(german_number,"zw\"olf");
      return(german_number);
   }
   if ((c1 == '1') && (c2 == '7'))
   {  sprintf(german_number,"siebzehn");
      return(german_number);
   }
   sprintf(german_number,"\0");
   if (c2 != '0')
   {  if ((c2 == '1') && (c1 != '0'))
         sprintf(german_number,"ein");
      else
         sprintf(german_number,"%s",DigitToWord(c2));
   }
   if ((c1 > '1') && (c2 != '0')) sprintf(german_number+strlen(german_number),"und");
   switch(c1)
   {
      case '1' : sprintf(german_number+strlen(german_number),"zehn"); break;
      case '2' : sprintf(german_number+strlen(german_number),"zwanzig"); break;
      case '3' : sprintf(german_number+strlen(german_number),"drei\"sig"); break;
      case '4' : sprintf(german_number+strlen(german_number),"vierzig"); break;
      case '5' : sprintf(german_number+strlen(german_number),"f\"unfzig"); break;
      case '6' : sprintf(german_number+strlen(german_number),"sechzig"); break;
      case '7' : sprintf(german_number+strlen(german_number),"siebzig"); break;
      case '8' : sprintf(german_number+strlen(german_number),"achtzig"); break;
      case '9' : sprintf(german_number+strlen(german_number),"neunzig"); break;
   }
   return(german_number);
}
