#!/bin/sh

#
# txt2pho.go 
#

# Script to speak German ASCII input. 
# We pipe ASCII input through 'pipefilt' to improve <newline> handling, 
# then through 'txt2pho' to produce phonemes,
# then through 'mbrola' synthesizer to get sound
# and finally to 'na_play' sound player.

# Syntax: cat <german_ascii_file> | txt2pho.go
# Syntax: echo "german words" | txt2pho.go

# Which voice do you want? m=male f=female
VOICE=m
#VOICE=f

# Where do we find the mbrola 'de2' voice?
LANGBASE=/usr/lib/mbrola/de2/de2

# Home directory of txt2pho
TXT2PHO_DIR="/usr/lib/mbrola/tts-German"


# We first have to change into the txt2pho homedir
# since txt2pho needs to run there.
cd $TXT2PHO_DIR

# Choose audio player
#./pipefilt | ./txt2pho $VOICE | mbrola -e $LANGBASE "-" -.au | na_play
./pipefilt | ./txt2pho $VOICE | mbrola -e $LANGBASE "-" -.raw | rawplay
